Subject: Absolute URI for WebEntry
Description

Hi,

I tried to configure an absolute URL for my entry point of a security provider. But it can't handle the absolute uri.

provider: MyProvider
entryPoint: 'WebRedirect'
entryPointOptions:
  uri: http://www.absolute-url.de/

I have created a patch.

Flow version: 2.1.1

Associated revisions
Revision 002aea5b - 2014-05-16 11:33 - Bastian Waidelich

[BUGFIX] Fix support for absolute URIs in WebRedirect options

Fixes support for authentication provider redirects to external
domains.

Background:

If a ``WebRedirect`` is configured with a relative URI like::
entryPoint: 'WebRedirect'
  entryPointOptions:
    uri: 'some/path'

The ``Location`` header gets properly prefixed with the current
base URI.
But due to a typo this happened as well for absolute URIs.

Note: using the "uri" option for internal redirects is deprecated,
use the ``routeParts`` option instead for those.

Change-Id: I203459da70465d78d50d226d265c88224ac50963
Fixes: #56598
Releases: master, 2.2, 2.1
Revision 96c42102 - 2014-05-26 20:21 - Bastian Waidelich

[BUGFIX] Fix support for absolute URIs in WebRedirect options

Fixes support for authentication provider redirects to external
domains.

Background:

If a ``WebRedirect`` is configured with a relative URI like::
entryPoint: 'WebRedirect'
  entryPointOptions:
    uri: 'some/path'

The ``Location`` header gets properly prefixed with the current
base URI.
But due to a typo this happened as well for absolute URIs.

Note: using the "uri" option for internal redirects is deprecated,
use the ``routeParts`` option instead for those.

Change-Id: I203459da70465d78d50d226d265c88224ac50963
Fixes: #56598
Releases: master, 2.2, 2.1

Revision 2de9d661 - 2014-06-18 22:30 - Bastian Waidelich

[BUGFIX] Fix support for absolute URIs in WebRedirect options

Fixes support for authentication provider redirects to external
domains.

Background:

If a ``WebRedirect`` is configured with a relative URI like::
entryPoint: 'WebRedirect'
  entryPointOptions:
    uri: 'some/path'

The ``Location`` header gets properly prefixed with the current
base URI.
But due to a typo this happened as well for absolute URIs.

Note: using the "uri" option for internal redirects is deprecated,
use the ``routeParts`` option instead for those.

Change-Id: I203459da70465d78d50d226d265c88224ac50963
Fixes: #56598
Releases: master, 2.2, 2.1
History
#1 - 2014-03-06 13:00 - Frederik Vosberg
- File bugfix-abs-uri-entry-point.diff added

#2 - 2014-03-06 14:18 - Bastian Waidelich
- Status changed from New to Needs Feedback
- Assigned To set to Bastian Waidelich
- Priority changed from Must have to Should have

FYI: The "uri" option of the WebRedirect entry point is deprecated. See 
http://docs.typo3.org/flow/TYPO3FlowDocumentation/TheDefinitiveGuide/PartIII/Security.html#authentication-entry-points

Can you please explain why you need an absolute URI here?

#3 - 2014-03-07 13:55 - Frederik Vosberg

Because I want to redirect to an external URL. And the way through a controller would be too much. Is there another way?

#4 - 2014-03-07 14:06 - Bastian Waidelich
- Category set to Security
- Status changed from Needs Feedback to Accepted

Frederik Vosberg wrote:

Because I want to redirect to an external URL. And the way through a controller would be too much. Is there another way?

Fair enough, but we should detect absolute URIs using parse_url() (like we do it in other places, for instance 
https://git.typo3.org/Packages/TYPO3.Fluid.git/blob/HEAD:/Classes/TYPO3/Fluid/ViewHelpers/Link/ExternalViewHelper.php#l65)
I'll take care of this

#5 - 2014-05-14 18:39 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30117

#6 - 2014-05-14 18:40 - Bastian Waidelich

I finally got around pushing this one. Sorry, I didn't know that this feature was already (incorrectly) implemented. I didn't look at your patch and thought
this was a new "feature"..

#7 - 2014-05-16 11:33 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30117

#8 - 2014-05-21 10:37 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:002aea5b7b7c5de25f25e79359e686de5a64f8e2.

#9 - 2014-05-26 20:21 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.2 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30428

#10 - 2014-05-26 20:36 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:96c42102f1f83276d5dd1da7b50e928376041234.

#11 - 2014-06-18 22:30 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30837

#12 - 2014-06-18 22:37 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:2de9d6619aa25ec109792fab7a00e8de3f7c7dfb.

Files
bugfix-abs-uri-entry-point.diff 1.6 kB 2014-03-06 Frederik Vosberg
